/*
 * zaptastic: an evil countdown
 * creative commons Attribution-NonCommercial 2.0 license
 *
 * This is an example of a widget that is evil, albeit not downright destructive.
 * It immediate goes to a web site when it loads.
 * It would be very easy to make it go to that web site over and over.
 * As in, every few milliseconds.  Even when the dashboard is hidden.
 * This would suck.  I don't even want to try that out.  Just not even curious.
 *
 * stephan@stephan.com
 * http://stephan.com/widgets/
 */
 
var updateFrequency = 5 * 60000; // every 5 minutes (but only when Dashboard is visible)
var zapURL = 'http://www.greenzap.com/stephancom';
var refreshInterval;

// Go to the site--different if you're testing in a browser vs. in Dashboard.
function gotoZap() {
	if (window.widget) {
		widget.openURL(zapURL);
	} else {
		window.location.href = zapURL;
	}
}

function updateZap()
{	
	var now = new Date();
	var nowMillis = Date.parse((1+now.getMonth())+"/"+now.getDate()+"/"+(1900+now.getYear()));
	var zapMillis = Date.parse("6/1/2005");
	
	var daysLeft = (zapMillis - nowMillis) / (24*60*60*1000);
	
	if(daysLeft<1) {
		document.getElementById("countdown").innerHTML = "Go Zap!";
		gotoZap();
		clearRefreshTimer(); // which is really quiet polite of me.
	} else if(daysLeft==1)
			document.getElementById("countdown" ).innerHTML = String( daysLeft )+" day";
		else
			document.getElementById("countdown" ).innerHTML = String( daysLeft )+" days";

	return;
}

// We don't want the widget refreshing when it's not on the screen, so these
// functions start and stop the refresh timer.
// If this program were really evil, we wouldn't bother being this nice.

function setRefreshTimer() {	 
    if (refreshInterval == null)
        refreshInterval = setInterval("updateZap();", updateFrequency);	 
}	 
 	 
function clearRefreshTimer() {	 
    if (refreshInterval != null) {	 
        clearInterval(refreshInterval);	 
        refreshInterval = null;
    }
}
              
function init() {
	gotoZap();

    if (window.widget) {	 
        widget.onshow = function OnShow() { // when Dashboard triggered	 
            setRefreshTimer();	 
            updateZap();	 
			gotoZap();
        }	 
        widget.onremove = function OnRemove() { // when widget discarded 
            clearRefreshTimer();	 
        }	 
        widget.onhide = function OnHide() { // when Dashboard dismissed	 
            clearRefreshTimer();	 
        }	 
    }	 
 	
    setRefreshTimer();
    
    updateZap();
}